#include <curses.h>
#include <unistd.h>

#define X_MAX	60
#define Y_MAX	20

#define	Y_RACKET	18
#define	RACKET_LEN	8

#define	W_MSEC	1000
#define	W_COUNT	100

void report ( int bx, int by, int rx ) {
  move ( 1, X_MAX + 1 );
  refresh();
  printf ( "bx=%d, by=%d rx=%d", bx, by, rx );
}

void erase_ball ( int bx, int by ) {
	move ( by, bx );
	addch ( ' ' );
}

void draw_ball ( int bx, int by ) {
	move ( by, bx );
	addch ( '*' );
}

void erase_racket ( int rx ) {
  int i;

  for ( i = 0; i < RACKET_LEN; i++ ) {
	move ( Y_RACKET, rx - RACKET_LEN / 2 + i );
	addch ( ' ' );
  }
}

void draw_racket ( int rx ) {
  int i;

  for ( i = 0; i < RACKET_LEN; i++ ) {
	move ( Y_RACKET, rx - RACKET_LEN / 2 + i );
	addch ( '=' );
  }
}

int main(void) {
  int ch;
  int bx = X_MAX/2;
  int by = Y_MAX/2;
  int dbx = 1;
  int dby = 1;
  int rx = X_MAX/2;
  int count = 0;

  initscr();
  cbreak();
  noecho();
  timeout(0);

  while ( 0 == 0 ) {
	usleep ( W_MSEC );

	count ++;

	if ( count > 100 ) {
	  count = 0;
	  /* report ( bx, by, rx ); */

	  erase_ball( bx, by );

	  bx = bx + dbx;

	  if ( bx < 0 ) {
		dbx = 1;
		bx = 1;
	  }
	  if ( bx > X_MAX ) {
		dbx = -1;
		bx = X_MAX-1;
	  }

	  by = by + dby;
	  if ( by < 0 ) {
		dby = 1;
		by = 1;
	  }
	  if ( by > Y_MAX ) {
		dby = -1;
		by = Y_MAX-1;
	  }

	  if ( by == Y_RACKET & rx - RACKET_LEN/2 <= bx && bx <= rx + RACKET_LEN/2 ){
		dby = -1;
	  }

	  draw_ball( bx, by );
	}

	ch = getch();

	erase_racket ( rx );
	if ( ch == 'h' ) {
	  if ( rx - RACKET_LEN/2 > 0 ) {
		rx--;
	  }
	} else if ( ch == 'l' ) {
	  if ( rx + RACKET_LEN/2 < X_MAX ) {
		rx++;
	  }
	} else if ( ch == 'q' ) {
	  break;
	}
	draw_racket ( rx );

	refresh();
  }

  endwin();

  return 0;
}
